Zotero.Maps = {
    SCHEME: "zotero://maps",
    
    channel: {
        CONTENT_URI: "chrome://zotero-maps/content/ui.html",
        newChannel: function (uri) {
            var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                      .getService(Components.interfaces.nsIIOService);
            try {
                var ext_uri = ioService.newURI(this.CONTENT_URI, null, null);
                var extChannel = ioService.newChannelFromURI(ext_uri);
                return extChannel;
            }
            catch (e){
                Zotero.debug(e);
                throw (e);
            }
        }
    },

    init: function () {
        var protocol = Components.classes["@mozilla.org/network/protocol;1?name=zotero"]
                                 .getService(Components.interfaces.nsIProtocolHandler)
                                 .wrappedJSObject;
        protocol._extensions[this.SCHEME] = this.channel;
    },
 
    load: function() {
        // get map types
        var params = {};
        window.openDialog("chrome://zotero-maps/content/type_selector.xul",
            "zotero-maps-type-selector", "chrome,modal=yes,resizable=no", params);
        
        if(!params.out) {
            return;
        }

        // create and load uri
        var uri = this.SCHEME + "/" + params.out.join("+");
       
        // map selected items was removed by Ben
        // because it seemed more annoying than helpful
        // Was implemented using: ZoteroPane.getSelectedItems(true)

        var id = ZoteroPane.getSelectedCollection(true);
        if (id) {
            window.loadURI(uri + '/collection/' + id);
            return;
        }
        
        id = ZoteroPane.getSelectedSavedSearch(true);
        if (id) {
            window.loadURI(uri + '/search/' + id);
            return;
        }
        
        id = ZoteroPane.getSelectedGroup().libraryID;
        if (id) {
            window.loadURI(uri + '/group/' + id);
            return;
        }

        window.loadURI(uri + '/library/');
    }
};

window.addEventListener('load', function(e) { Zotero.Maps.init(); }, false);
