var ZoteroMaps_TypeSelector = new function() {
    this.propertiesSrc = "chrome://zotero/locale/zotero.properties";
    this.propertiesPrefix = "itemFields.";
    this.prefs = null;
    this.checkboxes = null;

    // initialize localized checkbox labels
    this.onLoad = function() {
        this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                               .getService(Components.interfaces.nsIPrefService);
        this.prefs = this.prefs.getBranch("extensions.zotero-maps.");

        var localeService = Components.classes['@mozilla.org/intl/nslocaleservice;1']
                                      .getService(Components.interfaces.nsILocaleService);
        var appLocale = localeService.getApplicationLocale();
        var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"]
                                             .getService(Components.interfaces.nsIStringBundleService);
        var localeBundle = stringBundleService.createBundle(this.propertiesSrc, appLocale);

        this.checkboxes = document.getElementsByTagName("checkbox");
        for(var i = 0, len = this.checkboxes.length; i < len; i++) {
            var propertyName = this.propertiesPrefix + this.checkboxes[i].id;
            var label = localeBundle.GetStringFromName(propertyName);
            this.checkboxes[i].setAttribute("label", label);
        }
    };

    // return array of checked map types
    this.onAccept = function() {
        var selectedTypes = new Array();
        for(var i = 0, len = this.checkboxes.length; i < len; i++) {
            if(this.checkboxes[i].checked) {
                selectedTypes.push(this.checkboxes[i].id);
            }
        }
        window.arguments[0].out = selectedTypes;
    };
}

